#define SAVE_SCREEN
#define NO_EXIT_SUPPORT
#define USE_TI89
#define USE_TI92PLUS
#define MIN_AMS 200           // Compile for AMS 2.00 or higher
#include <tigcclib.h>         // Include all header files

short int music[173][2]={
{19,262},
{19,392},
{19,416},
{19,262},
{19,392},
{19,416},
{19,262},
{19,524},
{19,262},
{19,392},
{19,416},
{19,262},
{19,392},
{19,416},
{19,262},
{19,524},
{19,699},
{19,555},
{38,524},
{19,699},
{19,555},
{38,524},
{19,699},
{19,555},
{38,524},
{19,699},
{19,555},
{38,524},
{10,699},
{10,623},
{10,555},
{10,466},
{10,524},
{10,555},
{10,623},
{10,785},
{10,699},
{10,623},
{10,555},
{10,466},
{10,524},
{10,623},
{10,785},
{10,1048},
{19,262},
{19,392},
{19,416},
{19,262},
{19,392},
{19,416},
{19,262},
{19,524},
{19,699},
{19,555},
{38,524},
{19,699},
{19,555},
{38,524},
{10,699},
{10,623},
{10,555},
{10,466},
{10,524},
{10,555},
{10,623},
{10,785},
{10,699},
{10,623},
{10,555},
{10,466},
{38,1048},
{146,0},
{13,832},
{13,699},
{13,555},
{19,392},
{19,416},
{19,555},
{19,524},
{19,466},
{19,416},
{19,466},
{19,524},
{19,416},
{19,349},
{19,277},
{19,262},
{19,623},
{19,524},
{19,416},
{19,392},
{75,262},
{146,0},
{13,832},
{13,699},
{13,555},
{38,262},
{10,416},
{10,392},
{10,262},
{19,294},
{10,262},
{10,555},
{10,524},
{10,277},
{19,262},
{10,277},
{10,524},
{10,466},
{19,262},
{10,416},
{10,392},
{10,262},
{19,294},
{19,294},
{10,262},
{10,832},
{10,785},
{10,262},
{10,294},
{10,555},
{10,524},
{10,277},
{19,262},
{19,262},
{10,277},
{10,1048},
{10,277},
{19,262},
{38,1048},
{19,1110},
{19,1110},
{10,1048},
{19,1048},
{10,1048},
{10,832},
{19,832},
{10,832},
{10,785},
{10,699},
{10,555},
{10,524},
{29,416},
{29,349},
{19,277},
{29,416},
{29,349},
{19,262},
{29,416},
{29,349},
{19,277},
{25,416},
{25,349},
{25,262},
{13,392},
{13,392},
{13,392},
{13,392},
{13,392},
{13,392},
{25,416},
{25,416},
{25,416},
{13,392},
{13,392},
{13,392},
{13,392},
{13,392},
{13,392},
{38,416},
{38,416}};


// This contains the HW2 status.
// 0 for HW1s, 1 for HW2s. This is used because they are
// different for sound.
short hardwarever;

// This works through Auto-Int-5, as an always-going-counter.
volatile short count;
DEFINE_INT_HANDLER(count_int)
{
	++count;
}


//=============================================================================
// VTI detection routine (thanx, Julien Muchembled)
//
// this routine utilizes a bug in VTI: you can set even non-existing flags in
// the status register and query them later!
//=============================================================================
extern short IsVTI(void);
asm("IsVTI:    trap   #12;         /* enter supervisor mode. returns old (%sr) in %d0.w   */    move.w #0x3000,%sr; /* set a non-existing flag in %sr (but keep s-flag !!) */    swap   %d0;         /* save %d0.w content in upper part of %d0             */    move.w %sr,%d0;     /* get %sr content and check for non-existing flag     */    btst   #12,%d0;     /* this non-existing flag can only be set on the VTI   */    bne    __VTI;    swap   %d0;         /* restore old %sr content and return 0               */    move.w %d0,%sr;    moveq  #0,%d0;    rts;__VTI:    swap   %d0;         /* restore old %sr content and return 1                */    move.w %d0,%sr;     moveq  #1,%d0;     rts;");
short VTI;


void rest(long duree)
{
	short start = count;
	while (count - start < duree);
}
//Thanks to Francois Leiber for the beep() code.
//However, it has been slightly modified with ASM
//so it works with VTI's sound feature.
void beep(short freq, long duree)
{

	long int loop, maxloop ;
 short int delay;
	short int i, j;
if(VTI) duree=(duree*15)>>4;
maxloop = freq*duree/50;
j = peekIO(0x60000E);
freq = (hardwarever ? 364000 : 278000)/freq ;
asm("bset.b		#6,0x60000C");
	for (loop = 0 ; loop < maxloop ; loop++)
	{
asm("bchg.b		#0,0x60000E;bchg.b		#1,0x60000E;");
		for (i = 0 ; i <= freq ; i--) i += 2 ;
	}
asm("bclr.b 		#0,0x60000E;bclr.b 		#1,0x60000E;move.b 		#0x8D,0x60000C;");
for(delay=0;delay<(100*duree);delay+=2) delay--;
}


void _main(void)
{
  INT_HANDLER save_int_4 = GetIntVec(AUTO_INT_4);
  INT_HANDLER save_int_1 = GetIntVec(AUTO_INT_1);
  INT_HANDLER save_int_5 = GetIntVec(AUTO_INT_5);
  short int total = sizeof(music)/sizeof(music[0]);
  short int current=0;
  /* Checks the calculator hardware version */
	short *hwptr;
	hwptr = (short *)FL_getHardwareParmBlock();
 hardwarever = ((*hwptr)==20)?0:1;
 /*-----------------------------------------*/
 VTI=IsVTI();
 //Directs ints to nothing
  SetIntVec(AUTO_INT_4, DUMMY_HANDLER);
  SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
  //Auto Int 1 is called 350 times per second.
  SetIntVec(AUTO_INT_1, count_int);
  OSLinkReset();
  OSLinkOpen();
  clrscr();
printf("\n\nMalcolm Smith-Game Music 1");
printf("\n\n\nCreated by Midi68k\nBy Malcolm Smith\nhttp://jesystems.cjb.net\n\nHOLD Esc to Quit.");
  while( !(_keytest (RR_ESC)) && current<total)
  {
  if(!music[current][1]) rest(music[current][0]);
  else if(music[current][0]>0)  beep(music[current][1],music[current][0]);
  current++;
  }
	SetIntVec(AUTO_INT_4, save_int_4);
	SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_5, save_int_5);
 OSLinkReset();
 GKeyFlush();
 OSTimerRestart(APD_TIMER);
}

